/* just for testing; a small program to send a fd to lingerd */

#include "lingerd.h"
#include "config.h"

void die(s, p1, p2, p3) 
char *s; char *p1; char *p2; char *p3;
{
  fprintf(stderr, s, p1, p2, p3);
  fprintf(stderr, "\n");
  exit(1);
}

void pdie(char *s) {
  perror(s);
  exit(1);
}

int lingerd_connect() {
  int fd;
  struct sockaddr_un sadr;

  if ((fd = socket(PF_UNIX, SOCK_STREAM, 0)) < 0)
    return -1;

  sadr.sun_family = AF_UNIX;
  strncpy(sadr.sun_path, SOCKPATH, UNIX_PATH_MAX);
  sadr.sun_path[UNIX_PATH_MAX - 1] = '\0';

  if (connect(fd, (struct sockaddr *)&sadr, sizeof(sadr)) < 0) {
    close(fd);
    return -1;
  }

  return fd;
}

#define CONTROLLEN      (sizeof(struct cmsghdr) + sizeof(int))

int send_fd (int sockfd, int fd) {
  struct iovec iov;
  static struct cmsghdr *hdr = NULL;
  struct msghdr msg;
  char aracter = 'Z';

  if (hdr == NULL && 
      (hdr = (struct cmsghdr *)malloc(CONTROLLEN)) == NULL)
    return -1;

  hdr->cmsg_level = SOL_SOCKET;
  hdr->cmsg_len   = CONTROLLEN;
  hdr->cmsg_type  = SCM_RIGHTS;
  *(int *)CMSG_DATA(hdr) = fd;

  iov.iov_base    = &aracter;
  iov.iov_len     = 1;

  msg.msg_iov     = &iov;
  msg.msg_iovlen  = 1;
  msg.msg_name    = NULL;
  msg.msg_namelen = 0;
  msg.msg_flags	  = 0;
  msg.msg_control = hdr;
  msg.msg_controllen = CONTROLLEN;

  return sendmsg(sockfd, &msg, 0);
}

int main (int argc, char *argv[]) {
  int lingerd;
  int fds[2];
  
  if (socketpair(PF_UNIX, SOCK_STREAM, 0, fds) < 0)
    pdie("socketpair");

  if ((lingerd = lingerd_connect()) < 0)
    die("lingerd_connect failed");

  if (send_fd(lingerd, fds[1]) < 0)
    die("send_fd failed");

  close(fds[1]);
  sleep(1);

//  for (i=0; i<60; i++) {
    write(fds[0], "hello", 5);
    sleep(1);
//  }

  sleep(4);

  close(fds[0]);
  sleep(4);

  exit(0);

}


